module APEX_ADDED_SERVICES =
   process PROCESS_GETACTIVE =
        ( ? event request;
          ! ProcessID_type process_ID;
            ProcessStatus_type status;
        )
      (| (pid,pstatus,ok) := prag_PROCESS_GETACTIVE{}()
       | process_ID := pid when ok
       | status := pstatus when ok
       | ok ^= request
       |)
      where 
      ProcessID_type pid;
      ProcessStatus_type pstatus;
      boolean ok;
      process prag_PROCESS_GETACTIVE =
           ( ! ProcessID_type process_ID;
               ProcessStatus_type status;
               boolean ok;
           )
           spec (| process_ID ^= status ^= when ok |)
         pragmas 
            C_Code "&o1 = GLOBAL_PROCESS_MANAGER->ProcessGetActive( &o2, &o3)"
         end pragmas
      
      ; 
      end
   ; 
   process PROCESS_UPDATETIMECOUNTERS =
        ( ! [MAX_NUMBER_OF_PROCESSES]boolean timedout;
        )
      pragmas 
         C_Code "GLOBAL_PROCESS_MANAGER->ProcessUpdateTimeCounters(&o1)"
      end pragmas
   
   ; 
   process PROCESS_SCHEDULINGREQUEST =
        ( ? event request;
          ! boolean diagnostic;
        )
        spec (| (| request --> diagnostic |)
              | (| request ^= diagnostic |)
              |)
      pragmas 
         C_Code " &o1 = GLOBAL_PROCESS_MANAGER->ProcessSchedulingRequest()"
      end pragmas
   
   ; 
   process PROCESS_RECORDING =
        ( ? ProcessName_type name;
          ! boolean recorded;
        )
        spec (| name ^= recorded |)
      pragmas 
         C_Code "&o1 = GLOBAL_PROCESS_MANAGER->ProcessRecording(&i1)"
      end pragmas
   
   ; 
   process UPDATE_COUNTERS =
        ( ! [MAX_NUMBER_OF_PROCESSES]boolean timedout;
        )
      (| timedout := prag_UPDATECOUNTERS{}() |)
      where 
      process prag_UPDATECOUNTERS =
           ( ! [MAX_NUMBER_OF_PROCESSES]boolean timedout;
           )
         pragmas 
            C_Code "GLOBAL_PROCESS_MANAGER->ProcessUpdateTimeCounters(&o1)"
         end pragmas
      
      ; 
      end
   ; 
end %APEX_ADDED_SERVICES%; 
