module % APEX_%IntraCommunications_Manager_lib =

   process BLACKBOARD_CHECKID =
        ( ? Comm_ComponentID_type blackboard_ID;
          ! boolean present;
            APEX_Blackboard_type blackboard_OUT;
        )
        spec (| (| blackboard_ID --> present
                 | {blackboard_ID --> blackboard_OUT} when present
                 |)
              | (| blackboard_ID ^= present
                 | blackboard_OUT ^= when present
                 |)
              |)
      pragmas 
         C_Code "&o1 = GLOBAL_BLACKBOARD_MANAGER->BlackboardCheckID(&i1, &o2)"
      end pragmas
   
   ; 
   process BLACKBOARD_CHECKNAME =
        ( ? Comm_ComponentName_type blackboard_name;
          ! boolean present;
            Comm_ComponentID_type blackboard_ID;
        )
        spec (| (| blackboard_name --> present
                 | {blackboard_name --> blackboard_ID} when present
                 |)
              | (| blackboard_name ^= present
                 | blackboard_ID ^= when present
                 |)
              |)
      pragmas 
         C_Code "&o1 = GLOBAL_BLACKBOARD_MANAGER->BlackboardCheckName(&i1, &o2)"
      end pragmas
   
   ; 
   process BLACKBOARD_RECORD =
        ( ? Comm_ComponentName_type blackboard_name;
            MessageSize_type message_size;
          ! Comm_ComponentID_type blackboard_ID;
            boolean recorded;
        )
        spec (| (| {blackboard_name,message_size} --> recorded
                 | {{blackboard_name,message_size} --> blackboard_ID} when recorded
                 |)
              | (| blackboard_name ^= message_size ^= recorded
                 | blackboard_ID ^= when recorded
                 |)
              |)
      pragmas 
         C_Code "&o2 = GLOBAL_BLACKBOARD_MANAGER->BlackboardRecord(&i1, &i2, &o1);"
      end pragmas
   
   ; 
   process BLACKBOARD_UPDATE =
        ( ? APEX_Blackboard_type blackboard_IN;
        )
      pragmas 
         C_Code "GLOBAL_BLACKBOARD_MANAGER->BlackboardUpdate(&i1)"
      end pragmas
   
   ; 
   process BUFFER_CHECKID =
        ( ? Comm_ComponentID_type buffer_ID;
          ! boolean present;
            APEX_Buffer_type buffer_OUT;
        )
        spec (| (| buffer_ID --> present
                 | {buffer_ID --> buffer_OUT} when present
                 |)
              | (| buffer_ID ^= present
                 | buffer_OUT ^= when present
                 |)
              |)
      pragmas 
         C_Code "&o1 = GLOBAL_BUFFER_MANAGER->BufferCheckID(&i1, &o2)"
      end pragmas
   
   ; 
   process BUFFER_CHECKNAME =
        ( ? Comm_ComponentName_type buffer_name;
          ! boolean present;
            Comm_ComponentID_type buffer_ID;
        )
        spec (| (| buffer_name --> present
                 | {buffer_name --> buffer_ID} when present
                 |)
              | (| buffer_name ^= present
                 | buffer_ID ^= when present
                 |)
              |)
      pragmas 
         C_Code "&o1 = GLOBAL_BUFFER_MANAGER->BufferCheckName(&i1, &o2)"
      end pragmas
   
   ; 
   process BUFFER_RECORD =
        ( ? Comm_ComponentName_type buffer_name;
            BufferSize_type buffer_size;
            MessageSize_type message_size;
            QueuingDiscipline_type queuing_discipline;
          ! Comm_ComponentID_type buffer_ID;
            boolean recorded;
        )
        spec (| (| {buffer_name,buffer_size,message_size,queuing_discipline} --> recorded
                 | {{buffer_name,buffer_size,message_size,queuing_discipline} --> buffer_ID} when recorded
                 |)
              | (| buffer_name ^= buffer_size ^= message_size ^= queuing_discipline ^= recorded
                 | buffer_ID ^= when recorded
                 |)
              |)
      pragmas 
         C_Code "&o2 = GLOBAL_BUFFER_MANAGER->BufferRecord(&i1,&i2, &i3, &i4, &o1)"
      end pragmas
   
   ; 
   process BUFFER_UPDATE =
        ( ? APEX_Buffer_type buffer_IN;
        )
      pragmas 
         C_Code "GLOBAL_BUFFER_MANAGER->BufferUpdate(&i1)"
      end pragmas
   
   ; 
   process EVENT_CHECKID =
        ( ? Comm_ComponentID_type event_ID;
          ! boolean present;
            APEX_Event_type event_OUT;
        )
        spec (| (| event_ID --> present
                 | {event_ID --> event_OUT} when present
                 |)
              | (| event_ID ^= present
                 | event_OUT ^= when present
                 |)
              |)
      pragmas 
         C_Code "&o1 = GLOBAL_EVENT_MANAGER->EventCheckID(&i1, &o2)"
      end pragmas
   
   ; 
   process EVENT_CHECKNAME =
        ( ? Comm_ComponentName_type event_name;
          ! boolean present;
            Comm_ComponentID_type event_ID;
        )
        spec (| (| event_name --> present
                 | {event_name --> event_ID} when present
                 |)
              | (| event_name ^= present
                 | event_ID ^= when present
                 |)
              |)
      pragmas 
         C_Code "&o1 = GLOBAL_EVENT_MANAGER->EventCheckName(&i1,&o2)"
      end pragmas
   
   ; 
   process EVENT_RECORD =
        ( ? Comm_ComponentName_type event_name;
          ! Comm_ComponentID_type event_ID;
            boolean recorded;
        )
        spec (| (| event_name --> recorded
                 | {event_name --> event_ID} when recorded
                 |)
              | (| event_name ^= recorded
                 | event_ID ^= when recorded
                 |)
              |)
      pragmas 
         C_Code " &o2 = GLOBAL_EVENT_MANAGER->EventRecord(&i1,&o1)"
      end pragmas
   
   ; 
   process EVENT_UPDATE =
        ( ? APEX_Event_type event_IN;
        )
      pragmas 
         C_Code "GLOBAL_EVENT_MANAGER->EventUpdate(&i1)"
      end pragmas
   
   ; 
   process SEMAPHORE_CHECKID =
        ( ? Comm_ComponentID_type semaphore_ID;
          ! boolean present;
            APEX_Semaphore_type semaphore_OUT;
        )
        spec (| (| semaphore_ID --> present
                 | {semaphore_ID --> semaphore_OUT} when present
                 |)
              | (| semaphore_ID ^= present
                 | semaphore_OUT ^= when present
                 |)
              |)
      pragmas 
         C_Code "&o1 = GLOBAL_SEMAPHORE_MANAGER->SemaphoreCheckID(&i1, &o2)"
      end pragmas
   
   ; 
   process SEMAPHORE_CHECKNAME =
        ( ? Comm_ComponentName_type semaphore_name;
          ! boolean present;
            Comm_ComponentID_type semaphore_ID;
        )
        spec (| (| semaphore_name --> present
                 | {semaphore_name --> semaphore_ID} when present
                 |)
              | (| semaphore_name ^= present
                 | semaphore_ID ^= when present
                 |)
              |)
      pragmas 
         C_Code "&o1 = GLOBAL_SEMAPHORE_MANAGER->SemaphoreCheckName(&i1,&o2)"
      end pragmas
   
   ; 
   process SEMAPHORE_RECORD =
        ( ? Comm_ComponentName_type semaphore_name;
            SemaphoreValue_type current_value;
            SemaphoreValue_type maximum_value;
            QueuingDiscipline_type queuing_discipline;
          ! Comm_ComponentID_type semaphore_ID;
            boolean recorded;
        )
        spec (| (| {semaphore_name,current_value,maximum_value,queuing_discipline} --> recorded
                 | {{semaphore_name,current_value,maximum_value,queuing_discipline} --> semaphore_ID} when recorded
                 |)
              | (| semaphore_name ^= recorded ^= current_value ^= maximum_value ^= queuing_discipline
                 | semaphore_ID ^= when recorded
                 |)
              |)
      pragmas 
         C_Code "&o2 = GLOBAL_SEMAPHORE_MANAGER->SemaphoreRecord(&i1,&i2,&i3, &i4, &o1)"
      end pragmas
   
   ; 
   process SEMAPHORE_UPDATE =
        ( ? APEX_Semaphore_type semaphore_IN;
        )
      pragmas 
         C_Code "GLOBAL_SEMAPHORE_MANAGER->SemaphoreUpdate(&i1)"
      end pragmas
   
   ; 
   process BLACKBOARD_CHECKCAPACITY =
        ( ! boolean full;
        )
      pragmas 
         C_Code "&o1 = GLOBAL_BLACKBOARD_MANAGER->Full()"
      end pragmas
   
   ; 
   process BUFFER_CHECKCAPACITY =
        ( ! boolean full;
        )
      pragmas 
         C_Code "&o1 = GLOBAL_BUFFER_MANAGER->Full()"
      end pragmas
   
   ; 
   process EVENT_CHECKCAPACITY =
        ( ! boolean full;
        )
      pragmas 
         C_Code "&o1 = GLOBAL_EVENT_MANAGER->Full()"
      end pragmas
   
   ; 
   process SEMAPHORE_CHECKCAPACITY =
        ( ! boolean full;
        )
      pragmas 
         C_Code "&o1 = GLOBAL_SEMAPHORE_MANAGER->Full()"
      end pragmas
   
   ; 
end %APEX_IntraCommunications_Manager_lib%; 
